unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus;

type
  TDepart = class(TForm)
    procedure ApplicationActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Depart: TDepart;
  Pal : array[0..255] of integer;
  Afficher,first : boolean;
  OX,OY,pas : single;
  XC,YC : integer;
  affichageencours : boolean;

implementation

{$R *.DFM}
{$R CRS.RES}

Function Iteration(x,y,maxi:extended) : Integer;
var Ox,Oy,Dx,Dy : extended;
    k : integer;
begin
   OX := x;OY := y;
   For k := 0 To 255 do begin
      DX := x; DY := y;
      x := (DX * DX) - (DY * DY) + OX;
      y := (2 * DX * DY) + OY;
      If (x * x + y * y) > maxi Then begin
         Iteration := k + 1;Exit;
      End;
   end;
   Iteration := 0;
End;

procedure PaletteStandard;
var v1,v2,v3,k,p:integer;
begin
   p:=0;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256*256;p:=p+1; { rouges }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256;p:=p+1; { verts }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16;p:=p+1; { bleus }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256*256+k*16*256;p:=p+1; { rouges+verts }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256+k*16;p:=p+1; { verts + bleus}
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256*256+k*16;p:=p+1; { rouges + bleus }
   end;

   for k:=0 to 15 do begin
      pal[p]:=k*16*256*256+$FFFF;p:=p+1; { rouges + W }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256+$FF00FF;p:=p+1; { verts + W}
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16+$FFFF00;p:=p+1; { bleus + w}
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256*256+k*16*256+$FF;p:=p+1; { rouges+verts }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256+k*16+$FF0000;p:=p+1; { verts + bleus}
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*16*256*256+k*16+$FF00;p:=p+1; { rouges + bleus }
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*4*256*256+(16-k)*4*256; { gris }
      p:=p+1;
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*4*256+(16-k)*4; { gris }
      p:=p+1;
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*4*256*256+(16-k)*4; { gris }
      p:=p+1;
   end;
   for k:=0 to 15 do begin
      pal[p]:=k*4*256*256+(16-k)*4*256; { gris }
      p:=p+1;
   end;

end;



procedure AFFICHE;
var X,Y:integer;
    c : integer;
    Ev,Eh : integer;
begin
   affichageencours:=true;
   with Depart do begin
      cursor:=crhourglass;update;
      Canvas.Brush.Color := clblack;
      Canvas.FillRect(Rect(0,0,clientwidth,clientheight));
   end;
   Ev:=Depart.clientheight DIV 2;
   Eh:=Depart.clientwidth DIV 2;
   For y := -EV To EV do begin
      For x := -EH To EH do begin
         c := Iteration(OX + x * pas, OY + y * pas, 2);
         Depart.canvas.pixels[x + EH, y + EV]:= PAL[c];
      end;
   end;
   Depart.cursor:=5;
   affichageencours:=false;
end;

procedure Tdepart.ApplicationActivate(Sender: TObject);
begin
   Affiche;
end;
procedure TDepart.FormCreate(Sender: TObject);
const CR : integer = 5;
begin
   PaletteStandard;
   left:=(screen.width-width) DIV 2;
   top:=(screen.height-height) DIV 2;
   first:=true;
   OX := -0.5; OY := 0; pas := 4.6 / depart.clientwidth;
   Screen.Cursors[CR] := LoadCursor(HInstance, 'CROIX');
end;

procedure TDepart.FormResize(Sender: TObject);
begin
   if first then first:=false else Affiche;
end;

procedure TDepart.FormActivate(Sender: TObject);
var Q : integer;
begin
   Affiche;
   Q:=Application.MessageBox('Clique  gauche pour plonger dans le chaos, Clique  droite pour revenir sur tes pas.','Salut',mb_ok);
end;

procedure TDepart.FormClick(Sender: TObject);
begin
   if affichageencours then exit;
   Affiche;
end;

procedure TDepart.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   if affichageencours then exit;
   if Button=mbright then begin
      OX:=((X-(clientwidth DIV 2)) * pas)+OX;
      OY:=((Y-(clientheight DIV 2)) * pas)+OY;
      pas:=pas*5;
      affiche;
   end else begin
      OX:=((X-(clientwidth DIV 2)) * pas)+OX;
      OY:=((Y-(clientheight DIV 2)) * pas)+OY;
      pas:=pas/5;
   end;
end;

end.
